//Author: George Koutsogiannakis
//Institution: Illinois Institute of Technology
//Copying and usage for any other reason other than educational 
//is prohibited without the author's explicit authorization in writing.

//Date: 01/14/03
//updated 5/17/05
// updated 8/25/05
//correction to index in paintComponent made 1/29/06

import javax.swing.*;
import java.text.DecimalFormat;
import java.awt.Graphics;
import java.awt.*;
import java.awt.event.*;
import javax.swing.table.*;
import java.io.*;
import java.util.*;
import java.text.NumberFormat;
import java.text.DateFormat;

public class Mortgagecalculation extends JFrame 
{
	
	//global declarations. Values are accessible by all methods
	
	String interest;
	static double interestnumber;
	String time="0";
    String loanamount;
	String result;
	String string;
	static double timenumber;
	double decimalinterestnumber;
	static double loannumber;
	static double payment;
	double z;
	double x;
	double a;
	double y;
	static double totalpayments;
	static double totalinterest;
	static double principlek;
	static double balance;
	static Vector buffer=new Vector(30,50);
	Color color;
	Container c;
	DecimalFormat twodigits = new DecimalFormat("0.00");
    double loannumberk;
	DefaultTableModel mydefaulttable;
	JTable mytable;
	int k, l;
	JTextField loanamountfield, interestfield, timenumberfield;
	JTextArea centerarea;
	JButton submitbutton;
	int paintindex=0,index=0,m=0, temp;
	
	NumberFormat moneyFormat=NumberFormat.getCurrencyInstance(Locale.US);

	
	//default constructor
	public Mortgagecalculation()
	{

		

	}
	
	
	public Mortgagecalculation (String label)
	{
		super(label);
		constructGUI();
	}	
	public void constructGUI()
	{
		
		 c= getContentPane();
		
		//Construct the menus and their listeners

		JMenu filemenu = new JMenu("File");
		JMenuItem saveas= new JMenuItem ("Save Amortization As");
		saveas.addActionListener(new ActionListener(){
			public void actionPerformed (ActionEvent e)
			{
				JFileChooser filechooser = new JFileChooser ();
				filechooser.setFileSelectionMode ( JFileChooser.FILES_ONLY);
				int result = filechooser.showSaveDialog (null);
				if (result== JFileChooser.CANCEL_OPTION)
					
				{
					return;
				}
				File filename = filechooser.getSelectedFile();
				if (filename==null||filename.getName().equals (" "))
				{
					JOptionPane.showMessageDialog( null, "Invalid File Name", "Invalid FileName", JOptionPane.ERROR_MESSAGE );
				}
				else {
					try
					  {
						
						System.out.println("I am ready to create the streams");
						
						FileOutputStream file = new FileOutputStream(filename, true);
						
						OutputStreamWriter filestream = new OutputStreamWriter(new BufferedOutputStream(file));
						
						String info= "The data is based on"+"\n";
						
						filestream.write(info);
					
						System.out.println("I wrote the first string called info");
						
						String interestdata= "INTEREST:"+" "+interest+"\n";
						filestream.write(interestdata);
						String timedata="The amortization period is:"+" "+time+"\n";
						filestream.write(timedata);
						String loandata="The money borrowed is:"+" "+moneyFormat.format(loannumber)+"\n";
						filestream.write(loandata);
						String totals= "Total of Payments Made:"+" " +moneyFormat.format(totalpayments)+"\n"+"Total Interest Paid:"+"  "+moneyFormat.format(totalinterest)+"\n";
						filestream.write(totals);
						


						

						String filestring = "PAYMENT NUMBER"+"   " + "PAYMENT" + "   " + " PRINCIPLE" + "   " + "INTEREST" +"   " + " BALANCE" + "\n";
						filestream.write(filestring);
						double loannumberkf= loannumber;
						System.out.println(timenumber);
						
					
						for (int j=1; j<=timenumber ; j++ )
						{
							
							double principlekf=payment-loannumberkf*z;
							double balancef=loannumberkf-principlekf;
							String display ="\n"+ Integer.toString(j)+"                " + moneyFormat.format(payment)+"        "+ moneyFormat.format(principlekf)+ "     "+moneyFormat.format(loannumberkf*z)+ "     "+ moneyFormat.format(balancef)+"\n";
							filestream.write(display);
							loannumberkf=loannumberkf-principlekf;
							
					
						}
						filestream.flush();
						file.close();
					}
					catch ( IOException ioException )
					{
						JOptionPane.showMessageDialog (null, "File Does not exist", "Invalid File Name", JOptionPane.ERROR_MESSAGE);
					}
					
				}//end of else
				
			}
		   } //end anonymous inner class
	    );
		filemenu.add(saveas);
		JMenuItem exit= new JMenuItem ("Exit");
		exit.addActionListener( new ActionListener() {
				public void actionPerformed (ActionEvent e)
				{
					System.exit(0);
				}
			} //end anonymous inner class
		); // end call to ActionListener
		filemenu.add(exit);
		
		JMenuItem summaries=new JMenuItem ("Save Summaries As");
		MenuHandler menuhandler= new MenuHandler();
		summaries.addActionListener(menuhandler);
		filemenu.add(summaries);
		
		//construct the second JMenu

		JMenu colorchooser=new JMenu("Color Chooser");
		JMenuItem colorchooseritem=new JMenuItem("Choose Color");
		colorchooseritem.addActionListener (new ActionListener() {
						public void actionPerformed(ActionEvent e)
						{
							color=JColorChooser.showDialog(Mortgagecalculation.this, "Choose a Color", color);
							c.setBackground(color);
							c.repaint();
						}
					}
				 ); //end of registration
		colorchooser.add(colorchooseritem);
		
		
		
		//Create menu bar and add the two JMenu objects
		JMenuBar menubar = new JMenuBar();
		setJMenuBar(menubar);
		menubar.add(filemenu); // end of menu construction
		menubar.add(colorchooser);
		
		//set the layout manager for the JFrame
		c.setLayout(new BorderLayout(5,5));

		//construct table and place it on the North part of the Frame
		JLabel tablelabel=new JLabel ("The Table below displays amortization values after you press O.K. on the payments window. Payments window appears after you enter the values for rate, period and loan");
		mydefaulttable = new DefaultTableModel();
			mydefaulttable.addColumn("PAYMENT NUMBER");
			mydefaulttable.addColumn ("PAYMENT AMOUNT");
			mydefaulttable.addColumn ("PRINCIPLE");
			mydefaulttable.addColumn ("INTEREST");
			mydefaulttable.addColumn("LOAN BALANCE");
		
		Box tablebox=Box.createVerticalBox();    
		mytable=new JTable(mydefaulttable); 
		tablelabel.setLabelFor(mytable);

		JScrollPane myscrollpane= new JScrollPane (mytable);
		
		tablebox.add(tablelabel);
		tablebox.add(myscrollpane);
        	c.add (tablebox, BorderLayout.NORTH);
		
		//create center panel

		JLabel panellabel=new JLabel("Summarries");
		MyPanel panel =new MyPanel();
		panel.setSize (10, 50);
		
		panel.setBackground(Color.red);
		panellabel.setLabelFor(panel);
		
		Box panelbox=Box.createVerticalBox();
		panelbox.add(panellabel);
		panelbox.add(panel);
		c.add (panelbox, BorderLayout.CENTER);

		//add time in the SOUTH part of the Frame

		
		Panel southpanel=new Panel();
		southpanel.setBackground(Color.magenta);
		
		
		Date time=new Date();
		String timestring=DateFormat.getDateTimeInstance().format(time);
				
	   
		TextField timefield=new TextField("The Date and Time in Chicago is:"+" "+timestring, 50);
		southpanel.add(timefield);
		c.add(southpanel, BorderLayout.SOUTH);



		
		//USE "BOX LAYOUT MANAGER" TO ARRANGE COMPONENTS LEFT TO RIGHT WITHIN THE SOUTH PART OF THE FRAME
		
		
		//Create a text area to output more information about the application.Place it in a box and place box EAST
		
		Font f=new Font("Serif", Font.ITALIC+Font.BOLD, 16);
		
		
		string="-If you would like to exit this program\n"+
		"-click on the exit menu item \n"+
			"-if you would like to save the table as a text file \n"+
			"-click on Save As menu item \n"+"-You can reenter new values for calculation\n"+
			" as many times as you would like.\n"+
			"-You can save the summaries also on a different file\n"+
			"-Files are appended";
		
		JLabel infolabel= new JLabel ("Information About this Application", JLabel.RIGHT);
		JTextArea textarea=new JTextArea(25,25);
		textarea.setFont(f);
		textarea.append(string);
		infolabel.setLabelFor(textarea);
		Box box =Box.createVerticalBox();
		box.add(infolabel);
		box.add(new JScrollPane (textarea));
		c.add(box, BorderLayout.EAST);

		//Create the text fields for entering data and place them in a box WEST
		
		Panel panelwest = new Panel();
		
		
		//create the first panelwest and place the text fields in it
		Box box1=Box.createVerticalBox();
		JLabel rate= new JLabel ("Enter Rate", JLabel.RIGHT);
		interestfield=new JTextField ("Enter Interest here and press Enter", 15);
		rate.setLabelFor(interestfield);
		box1.add(rate);
		box1.add(interestfield);
		JLabel period=new JLabel("Enter Amortization Periods", JLabel.RIGHT);
		timenumberfield=new JTextField("Enter amortization period in months and press Enter", 15);
		period.setLabelFor(timenumberfield);
		box1.add(period);
		box1.add(timenumberfield);
		JLabel loan=new JLabel("Enter Present Value of Loan", JLabel.RIGHT);
		loanamountfield =new JTextField ("Enter amount of loan and press Enter", 15);
		loan.setLabelFor(loanamountfield);
		box1.add(loan);
		box1.add(loanamountfield);
		JLabel submit = new JLabel("Press Submit Button to Calculate", JLabel.RIGHT);
		submitbutton= new JButton("SUBMIT");
		submit.setLabelFor(submitbutton);
		box1.add(submit);
		box1.add(submitbutton);
		panelwest.add(box1);
		
		
		
		
		
		
		
		
		//Add the panel to the content pane
		c.add(panelwest, BorderLayout.WEST);

		//Event handler registration for text fields and submit button

		TextFieldHandler handler=new TextFieldHandler();
		interestfield.addActionListener(handler);
		timenumberfield.addActionListener(handler);
		loanamountfield.addActionListener(handler);
		submitbutton.addActionListener(handler);
		setSize(1000, 700);    
		setVisible(true);

		
		
		System.out.println("repainting table, constructor");
	
		
		
		System.out.println("I finished repainting. End of ConstructGUI");
		
		
	} // END OF CONSTUCTGUI
	
	public void calculate()
	{
			//This method is called after the listener handler for the text fields has been activated.
			decimalinterestnumber=interestnumber*0.01;
			System.out.println(decimalinterestnumber);
			z= decimalinterestnumber/12;
			a= (1+z);
			System.out.println(a);
			x= Math.pow( a, timenumber);
			System.out.println(timenumber);
			System.out.println(x);
			y=  1- (1/x);
			payment= (loannumber*z) / y;
			System.out.println(payment);
		//Format the payment number two a two digit format to the right of the decimal point.
		//Class decimalFormat belongs to package java.text
		
		//save timenumber everytime a new data is submitted by user
			
			
			result="Your montly payment is:"+" "+"$"+" "+twodigits.format(payment);
			JOptionPane.showMessageDialog(this, result , "MONTLY PAYMENT" , JOptionPane.INFORMATION_MESSAGE); 
			System.out.println("I am done with dialog box and now I am going to paint, I am inside calculate method now");
			paintindex++;
			if (paintindex>=1)
			{
				
				repaint();
			}
			 //call to the paint methods is being made (both paint and paintComponent methods)
			//the effect is that the paint method passes the values to the JTable and paintComponent method 
			//passes the values to the center panel on the south part.
			//we want to capture the value of index at the time calculate was called.
			temp=index;
	}

	public static void main (String args[] )
	{
		Mortgagecalculation m=new Mortgagecalculation("FINANCIAL CALCULATOR");
		m.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

	}

	

	public void paint(Graphics g)
	{
		
	  
	 
		super.paint(g);
		
		System.out.println("repainting, inside paint method");
		
		//Pass the values to the table model after the calculations have been performed.
		int l=mydefaulttable.getRowCount();
		System.out.println(l);
			
			loannumberk=loannumber;
			 
			 for (k=1; k<=timenumber ; k++ )
			 {
					
					principlek=payment-loannumberk*z;
					balance=loannumberk-principlek;
					String[] display = { Integer.toString(k), moneyFormat.format(payment),  moneyFormat.format(principlek), moneyFormat.format(loannumberk*z), moneyFormat.format(balance)};
					
					loannumberk=loannumberk-principlek;
					if (paintindex==1)
					{
						//adds a row to the end of the model
						mydefaulttable.addRow(display);
					}
					
					else if(paintindex>1&&k<l)
					
					{
						
						mydefaulttable.setValueAt(Integer.toString(k), k-1, 0);
						mydefaulttable.setValueAt(moneyFormat.format(payment), k-1, 1);
						mydefaulttable.setValueAt(moneyFormat.format(principlek), k-1, 2);
						mydefaulttable.setValueAt(moneyFormat.format(loannumber*z), k-1, 3);
						mydefaulttable.setValueAt(moneyFormat.format(balance), k-1, 4);
						
						
						
					}//end of else if
					else if (paintindex>1&&k>l)
					{
					     mydefaulttable.addRow(display);
					


					}
			} //end of for loop
			System.out.println(k);
			
			//get rid of duplicate rows added every time the mouse clicks. Mouse clicks cause new calls to paint and repaint!!
			//restrict rows to the number of periods the user entered. We can also use repaint index to restrict repainting of table
			//since repaint index represents the lgitimate number of calls to calculate() method
			m=Integer.parseInt(time);
			mydefaulttable.setRowCount(m);
			
			System.out.println("new payment, I am inside paint method"+payment);
			
		
		
	
	} //end of paint method

  class  MyPanel extends JPanel
  {
	 
	 
	 //Vector buffer=new Vector(30,50);
		
	 
	 public MyPanel()
	 {
		 centerarea= new JTextArea(10,30);
		 JScrollPane textscrollpane= new JScrollPane (centerarea);
		 add(textscrollpane);
		
	 }


	 public Vector createBuffer()
	 {
			
		
			
			 totalpayments=timenumber*payment;
		     totalinterest = totalpayments-loannumber;
			
			
			buffer.addElement("\n"+"Given the interest:"+" "+interestnumber);
			buffer.addElement("and the loan amount of"+" "+moneyFormat.format(loannumber));
			buffer.addElement("over the period of" + "  "+timenumber+"  "+"months");
			buffer.addElement("The total payment is :"+" "+moneyFormat.format(totalpayments));
			buffer.addElement("The total interest paid is :"+" "+moneyFormat.format(totalinterest));
			buffer.addElement("--------------------");
			return buffer;
	 }
	//Paint method for panel container
	 public void paintComponent (Graphics g)
	 {
		super.paintComponent(g);
		index++;
		//index counts the number of times paint component has been called.	
		//temp ha scaptured the value of index at the time the call to calculate was made
		//subtract 1 from index because paintComponent is called one more time after calculate()
		if(paintindex>=1&&(index-1)==temp)
		 {	
			
		
		
			System.out.println("the value of paintindex inside paintComponent:"+paintindex);
			
			Vector buffer1=createBuffer();
		    
			int size=buffer1.size();
			for (int j=((paintindex-1)*6); j<size; j++ )
			{
			 centerarea.append("\n"+" "+buffer1.elementAt(j));
			
			}
			System.out.println("The size of the buffer in MyPanel is:"+size);

			for (int j=((paintindex-1)*6); j<size; j++ )
			{
				System.out.println("\n"+" "+buffer1.elementAt(j));
			
			}
		 }
		
		System.out.println("paint component has been called "+index+" times versus a number of calculate() calls  equal to "+paintindex);
		
	 }

	
   }
   
   



   
   class TextFieldHandler implements ActionListener
	{
		public void actionPerformed (ActionEvent event)
		{
			if (event.getSource()== interestfield)
			{
				interest=event.getActionCommand();
				interestnumber = Double.parseDouble(interest);
			}
			else if (event.getSource()== timenumberfield)
			{
				time=event.getActionCommand();
				timenumber = Double.parseDouble(time);
			}
			else if (event.getSource()== loanamountfield)
			{
				loanamount=event.getActionCommand();
				loannumber=Double.parseDouble(loanamount);
				calculate();		
			}
			else
			{
				interest=interestfield.getText();
				interestnumber=Double.parseDouble(interest);
				time=timenumberfield.getText();
				timenumber=Double.parseDouble(time);
				loanamount=loanamountfield.getText();
				loannumber=Double.parseDouble(loanamount);
				calculate();
			}
			
		}
	}

  
}

